//+w168 +h105
//+w540 +h315 
//+w840 +h525 +a0.3 
//+w1080 +h630 +a0.3
//+w1680 +h1050 +a0.3


#declare ShowMedia=off;
#declare ShowPlanet=on;
#declare ShowWater=on;
#declare ShowClouds=off;
#declare ShowRings=on;   
#declare HighQuality=off; 
#declare Rad=off; 

#declare FinalRender=2;//0//1//2



#switch (FinalRender)  

  #case (1) // No Radiosity
        #declare ShowMedia=on;
        #declare ShowPlanet=on;
        #declare ShowWater=on;
        #declare ShowClouds=on;
        #declare ShowRings=on;   
        #declare HighQuality=off; 
        #declare Rad=off; 
  #break 

  #case (2) // Radiosity
        #declare ShowMedia=on;
        #declare ShowPlanet=on;
        #declare ShowWater=on;
        #declare ShowClouds=on;
        #declare ShowRings=on;   
        #declare HighQuality=on; 
        #declare Rad=on; 
  #break 
#end
 
 
global_settings{
  //assumed_gamma 1
  //max_trace_level 256 
  //adc_bailout 0.003922
  
  #if(Rad)
  radiosity{//recursion_limit 2  
        count 1600
        //adc_bailout .3 
        normal on 
        media on 
       //save_file "file_name"       // save radiosity data
      //load_file "file_name"       // load saved radiosity data
        } 
  #end      
}
//#default{texture{finish{ambient 0}}}
#include "functions.inc"
                       



//Stars ////////////////////////////////////////////////

#declare Turb=1.3;

#declare star_pig1=
          pigment {
                
                    crackle 
                    form<1,1,0> 
                    scale .001//.01
                
                    color_map {
                              [0 color rgb 1/2]
                              [0.4 color rgb <1.0, 0.9, 0.5>/2] 
                              [0.6 color rgb <1.0, 0.5, 0.5>/2]
                              [0.8 color rgb <0.1, 0.3, 0.5>/2]
                              [1 color rgb 0]
                              //[1 color rgb 0]
                              }
                
                  } 


#declare star_pig2=
          pigment {
                
                    crackle 
                    form<1,1,0> 
                    scale .001//.01
                
                    color_map {
                              [0 color rgb <.98,.99,1>/2]
                              [0.1 color rgb <1.0, 0.9, 0.5>/2] 
                              [0.4 color rgb <1.0, 0.5, 0.5>/2]
                              [0.6 color rgb <0.1, 0.3, 0.5>/4]
                              [0.7 color rgb <0.01, 0.1, 0.4>/8]
                              [.8 rgb 0]
                              }
                
                  } 
                  
#declare star_pig3=
          pigment {
                
                    crackle 
                    form<1,1,0> 
                    scale .001//.01
                
                    color_map {
                              [0 color rgb 1/2]
                              [0.25 color rgb <1.0, 0.9, 0.5>/2] 
                              [0.3 color rgb <1.0, 0.5, 0.5>/4]
                              [0.4 color rgb <0.1, 0.3, 0.5>/8]
                              [0.5 color rgb <0.01, 0.1, 0.4>/10]
                              [0.6 color rgb 0]
                              }
                
                  }                   
                  
                  
#declare Galaxy=
                  pigment{
                    wrinkles
                    omega .7
                    pigment_map {
                      [.6 star_pig3]
                      
                      
                       [.8 star_pig2]
                       [1 star_pig1]
                    }
                  }

#declare star_pig=
          pigment {
                
                    crackle 
                    form<1,1,0> 
                    scale .001//.01
                
                    color_map {
                              [0 color rgb 1]
                              [0.25 color rgb <1.0, 0.9, 0.5>] 
                              [0.3 color rgb <1.0, 0.5, 0.5>]
                              [0.4 color rgb <0.1, 0.3, 0.5>]
                              [0.5 color rgb <0.01, 0.1, 0.4>]
                              [0.6 color rgb 0]
                              }
                
                  } 
                  
//sky_sphere{pigment{Galaxy scale .1 rotate x*30}}  

/////////////////////////////////////////////////////

// *** PLANET Bue ***

#declare t_planet=
pigment{
           onion    warp { turbulence 0.01 lambda 33 }
           color_map{
                    [.6 rgb <.02,.1,.2>]
                    [.785 rgb <.6,.5,.4>]
                    [.8 rgb <.011,.18,.21>]    // green
                    [.99 rgb <.01,.15,.2>]//<.1,.2,.01>]      // green    
                    [1 rgb <.6,.5,.4>]
                    }
                  scale 1/(<1.01,.995,1.01>)
                  }

#declare t_planet1=
pigment{
           onion    warp { turbulence 0.01 lambda 33 }
           color_map{
                    [0 rgb .8]
                    [.6 rgb <.02,.1,.2>]
                    [.785 rgb <.6,.5,.4>]
                    [1 rgb .7]
                    }
                  scale 1/(<1.01,.995,1.01>)
                  }

#declare t_planet2=
pigment{
           onion    warp { turbulence 0.01 lambda 33 }
           color_map{
                    [.6 rgb <.02,.1,.2>]
                    [.785 rgb <.6,.5,.4>]
                    [.93 rgb <.011,.18,.21>]    // green
                    }
                  scale 1/(<1.01,.995,1.01>)
                  }

#declare t_planet3=
pigment{
           onion    warp { turbulence 0.01 lambda 33 }
           color_map{
                    [.6 rgb <.02,.1,.2>]
                    [.785 rgb <.6,.5,.4>]
                    [.8 rgb <.011,.11,.21>]    // green
                    [.99 rgb <.11,.15,.2>]//<.1,.2,.01>]      // green    
                    [1 rgb <.6,.5,.4>]
                    }
                  scale 1/(<1.01,.995,1.01>)
                  }

#declare t_planet= // Bue texture
texture{
  pigment{
           onion    scale <1.01,.995,1.01>
           turbulence .0005
           lambda 2.5
           omega 1.2
           pigment_map{
                    [0 t_planet1]
                    [.05  t_planet ]
                    [.3  t_planet3 ]  
                    [.5  t_planet2 ] 
                    [.7  t_planet3 ]
                    [.95  t_planet ] // sand
                    [1 t_planet1]//<.1,.2,.01>]
                    }
          }
        normal {agate scale .001} 
        finish{ambient 0}
        }  
//////////////////////////////////////////////////        
//Har Texture

 #macro FracBump(Recursions)
     #local Count=0;
     
     #while (Count<Recursions)
      //gradient x  rotate y*30 
      //gradient x rotate y*15  
      crackle
      //rotate Count*30
      //triangle_wave     
      warp{turbulence .3}
      scale .5 // warp{turbulence .5}
      normal_map{[.099 crackle (Recursions-Count)*.5 slope_map {[0 <-1,-1>][.1 <1,-1>][1 <.9,0>]}]    
                  [.1 
     
      #local Count=Count+1;
     #end 
     
     //bozo 
     crackle scale Count/.5 slope_map {[0 <1,-1>][1 <.9,0>]}
     
     #while (Count>0)
      ]
      }
     #local Count=Count-1;
     #end
     
     
#end 

 #declare Fract_colors =spline {linear_spline 2,<.11,.1,.09>*.001,  7,<.15,.13,.1> };// spline {  linear_spline  0, <.5,.2,.1>*.3,4.5, <.3,.2,.1> };
 
#macro FracTex(Recursions)
     #local Count=0;
     
     #while (Count<Recursions)
      crackle
      //rotate Count*30
      //triangle_wave     
      warp{turbulence .3}
      scale .5 
      texture_map{[0 pigment{ rgb Fract_colors(Count)}
                     normal{crackle (Recursions-Count)*.5 slope_map {[0 <-1,1>][.1 <1,-1>][1 <0,0>]}}
                   ]    
                  [.1 
     
      #local Count=Count+1;
     #end 
     
     pigment{rgb  Fract_colors(Count) }
     normal{ crackle  Count/.5 slope_map {[0 <-1,1>][.1 <1,-1>][1 <0,0>]} }
     
     #while (Count>0)
      ]
      }
     #local Count=Count-1;
     #end
     
     
#end

#declare t_planet_Har=//texture{  FracTex(5) scale .03 } 
 
texture{

           leopard    warp { turbulence 0.1  } 
            scale .5  
           translate <1,-.2,-1>
           texture_map{
                    //[0 pigment{ rgb <1.5,.5,.1> }]
                    [.5 //rgb <.5,.2,.1>
                     FracTex(4) scale .1  //.05
                    ]//rgb <1,.5,0> ]  
                     
                      #declare Fract_colors = spline {linear_spline 2, .000001,  11,<.15,.13,.1>*.0001};
                     
                    [1// pigment{ rgb 0}
                      FracTex(4) scale .1 
                    ]    
                    }
                    
  
} 

 #declare Fract_colors = spline {linear_spline 2,<.11,.1,.09>*.01,  7,<.12,.11,.1> };//spline { linear_spline  0, <.5,.2,.1>*.3,4.5, <.3,.2,.1> };

#macro FracTex2(Recursions)
     #local Count=0;
     
     #while (Count<Recursions)
      crackle
      //rotate Count*30
      //triangle_wave     
      warp{turbulence .3}
      scale .5 
      texture_map{[0 pigment{ rgb Fract_colors(Count)}
                     normal{crackle 2 }//slope_map {[0 <-1,1>][.1 <1,-1>][1 <0,0>]}}
                   ]    
                  [.1 
     
      #local Count=Count+1;
     #end 
     
     pigment{rgb  Fract_colors(Count) }
     normal{ crackle 2  }//slope_map {[0 <-1,1>][.1 <1,-1>][1 <0,0>]} }
     
     #while (Count>0)
      ]
      }
     #local Count=Count-1;
     #end
     
     
#end

#declare t_planet_Har=
texture{

           onion    //scale <1.01,.995,1.01>
           turbulence .0005
           lambda 2.5
           omega 1.2
           texture_map{
                     [0 pigment{ rgb 0 } ]
                    [.6 //rgb <.5,.2,.1>
                     //FracTex(5) scale .2  //.05  
                      t_planet_Har
                    ]//rgb <1,.5,0> ]  
                    
                    #declare Fract_colors = spline {linear_spline 2,<.12,.11,.1>*.1, 4,<.11,.1,.09>*.001 };
                    [.8 //rgb <.5,.2,.1>
                     crackle //scale 2
                     texture_map{
                             [0
                             FracTex2(4) scale.3
                             ]    
                             [.5 
                             pigment{rgb .001}
                             normal{crackle 2}  
                             finish{roughness.05 brilliance 2}
                             ]
                             }
                      //.05
                    ]//rgb <1,.5,0> ] 
                     //[1 pigment{ rgb 2 }]
                     // 
                     
                        
                    }
                 
                    /*
                   [0 t_planet1]
                    [.05  t_planet ]
                    [.3  t_planet3 ]  
                    [.5  t_planet2 ] 
                    [.7  t_planet3 ]
                    [.95  t_planet ] // sand
                    [1 t_planet1]//<.1,.2,.01>]
                     */
        

}
/////////////////////////////////////////////////////////////////


#declare Scalar=<4,1,4>;
#declare Rotar= <-15,0,0>; //<0,0,0>; //<60,0,16>; //<15,0,0>;//




        // }
#declare d_clouds=
          density{
                   wrinkles  scale <100,50,100>*22
                   turbulence <1,2,1>
                   lambda 2.5
                   omega 1.3
                   warp { turbulence <10,0,10>*.1
                         //lambda 3
                         omega 1.2
                         }
                   density_map{
                            [0 rgb 0]
                            [.3 granite scale 1/(<100,50,100>*22) density_map{[0 rgb 0][.7 rgb 200]}]  
                            [1 rgb 200]
                            }
                   rotate y*15
                   scale<0.021,0.02,0.021>/Scalar
                   rotate -Rotar
                  }
#declare d_clouds2=
          density{ wrinkles  rotate Rotar
                   scale Scalar
                   //lambda 2.5
                   omega 1.3
                   density_map{
                            [.1 rgb 0 ]
                            [.6 granite scale 3 density_map{
                                                [.5 rgb 0]
                                                [.7 granite scale .1 
                                                density_map{
                                                        [0 rgb 0]
                                                        [.7 granite scale .1 density_map{[.5 rgb 0][.6 rgb 10][1 rgb 200]}]
                                                        
                                                        [1 rgb 200]
                                                        }
                                                
                                                ] 
                                                
                                                [.8 rgb 100]
                                                [1 rgb 200]
                                                }
                            ]
                           [1 rgb 0]
                            }
                   rotate y*-5
                   scale<0.021,0.02,0.021>/Scalar
                   rotate -Rotar
                  }


#declare d_clouds3=
          density{ wrinkles warp { turbulence 0.3}  rotate Rotar
                   scale Scalar
                   //lambda 2.5
                   omega 1.3  
                   //octaves 2 
                warp {
                    turbulence 6     // amount of turbulence
                    octaves 3.3          // optional turbulence modifiers  
                    lambda 2.3
                    omega 1.3 
                  }   

                   density_map{
                            [.4 rgb 0 ]
                            [.7 granite scale .1 density_map{[.5 rgb 1][.6 rgb 100]}]
                            
                            [.9 wrinkles scale .1 density_map{[.5 rgb 100][.6 rgb 200]}]
                            [1 rgb 200]
                            }
                   rotate y*-5
                   scale<0.021,0.02,0.021>/Scalar
                   rotate -Rotar
                  }


#declare d_clouds4=
          density{ wrinkles  
                   //phase .25
                   poly_wave .2  
                   //frequency 3
                        
                   turbulence 0.03 
                   rotate Rotar
                   scale Scalar
                   //lambda 2.5
                   omega 1.3  
                   //octaves 2 
            
                warp {
                    turbulence .6     // amount of turbulence
                    octaves 3.3          // optional turbulence modifiers  
                    lambda 2.3
                    omega 1.3 
                  }   
                    scale .5
                   density_map{
                            [0 granite scale 10 
                                   density_map{
                                                [0 rgb 100]
                                                [.7 granite scale .01 
                                                         density_map{
                                                                [0 rgb 100] 
                                                                [.7 granite poly_wave 4 scale .001 density_map{[0 rgb 200][.3 rgb 100][1 rgb 200]}]
                                                                
                                                                [1 rgb 100]
                                                                }
                                                ] 
                                                [1 rgb 100]
                                                }
                            ]                          
                            [.3 granite scale 10 
                                   density_map{
                                                [0 rgb 0]
                                                [.7 granite scale .01 
                                                        density_map{
                                                                [0 rgb 0] 
                                                                [.7 granite poly_wave 4 scale .1 density_map{[0 rgb 50][.3 rgb 0][1 rgb 50]}]
                                                                
                                                                [1 rgb 0]
                                                                }
                                                
                                                ] 
                                                [1 rgb 0]
                                                }
                            ] 
                            
                            [.7 rgb 0]  
                            
                            [.85 granite scale 10 
                                   density_map{
                                                [0 rgb 0]
                                                [.7 granite scale .01 
                                                   
                                                           
                                                          
                                                 density_map{
                                                        [0 rgb 0] 
                                                        [.7 granite poly_wave 4 scale .1 density_map{[0 rgb 50][.3 rgb 0][1 rgb 50]}]
                                                        
                                                        [1 rgb 0]
                                                        }
                                                
                                                ] 
                                                [1 rgb 0]
                                                }
                            ] 
                            
                            [1 granite scale 10 
                                   density_map{
                                                [0 rgb 100]
                                                [.7 granite scale .01 
                                                   
                                                           
                                                          
                                                 density_map{
                                                        [0 rgb 100] 
                                                        [.7 granite poly_wave 4 scale .001 density_map{[0 rgb 200][.3 rgb 100][1 rgb 200]}]
                                                        
                                                        [1 rgb 100]
                                                        }
                                                
                                                ] 
                                                [1 rgb 100]
                                                }
                            ] 
                            }
                   rotate y*-5
                   scale<0.021,0.02,0.021>/Scalar
                   rotate -Rotar
                  }



// Cloud texture 
#declare t_clouds1=

          density{
                   wrinkles  scale <100,50,100>*22
                   turbulence <1,2,1>
                   lambda 2.5
                   omega 1.3
                   warp { turbulence <10,0,10>*.1
                         //lambda 3
                         omega 1.2
                         }
                   density_map{
                            [0 rgb 1 transmit 1]
                            [.3 rgb 1 transmit .9]
                            [1 rgb 1 transmit 0]
                            }
                   rotate y*15
                   scale<0.021,0.02,0.021>/Scalar
                   rotate -Rotar
                  }
        
#declare t_clouds=
density{ wrinkles  rotate Rotar
                   scale Scalar
                   //lambda 2.5
                   omega 1.3
                   density_map{
                            [0 t_clouds1 ]
                            [.3 rgb 1 transmit 1]
                            [.5 t_clouds1]
                            [.7 rgb 1 transmit 1]
                            [1 t_clouds1 ]
                            }
                  }
#declare p_clouds3=
          pigment{ wrinkles warp { turbulence 0.3}  rotate Rotar
                   scale Scalar
                   //lambda 2.5
                   omega 1.3  
                   //octaves 2 
                warp {
                    turbulence 6     // amount of turbulence
                    octaves 3.3          // optional turbulence modifiers  
                    lambda 2.3
                    omega 1.3 
                  }   

                   pigment_map{
                            [.4 rgbt 1 ]
                            [.7 granite scale .1 pigment_map{[.5 rgbt <1,1,1,.1>][.6 rgb 1]}]
                            
                            [.9 wrinkles scale .1 pigment_map{[.5 rgb 1][.6 rgb 2]}]
                            [1 rgb 2]
                            }
                   rotate y*-5
                   scale<0.021,0.02,0.021>/Scalar
                   rotate -Rotar
                  }
                  
#declare p_clouds4=
          pigment{ wrinkles  
                   //phase .25
                   poly_wave .2  
                   //frequency 3
                        
                   turbulence 0.03 
                   rotate Rotar
                   scale Scalar
                   //lambda 2.5
                   omega 1.3  
                   //octaves 2 
            
                warp {
                    turbulence .6     // amount of turbulence
                    octaves 3.3          // optional turbulence modifiers  
                    lambda 2.3
                    omega 1.3 
                  }   
                    scale .5
                   pigment_map{
                            [0 granite scale 10 
                                   pigment_map{
                                                [0 rgb 1]
                                                [.7 granite scale .01 
                                                         pigment_map{
                                                                [0 rgb 1] 
                                                                [.7 granite poly_wave 4 scale .001 pigment_map{[0 rgb 2][.3 rgb 1][1 rgb 2]}]
                                                                
                                                                [1 rgb 1]
                                                                }
                                                ] 
                                                [1 rgb 1]
                                                }
                            ]                          
                            [.3 granite scale 10 
                                   pigment_map{
                                                [0 rgbt 1]
                                                [.7 granite scale .01 
                                                        pigment_map{
                                                                [0 rgbt 1] 
                                                                [.7 granite poly_wave 4 scale .1 pigment_map{[0 rgbt <1,1,1,.5>][.3 rgbt 1][1 rgbt <1,1,1,.5>]}]
                                                                
                                                                [1 rgbt 1]
                                                                }
                                                
                                                ] 
                                                [1 rgbt 1]
                                                }
                            ] 
                            
                            [.7 rgbt 1]  
                            
                            [.85 granite scale 10 
                                   pigment_map{
                                                [0 rgbt 1]
                                                [.7 granite scale .01 
                                                   
                                                           
                                                          
                                                 pigment_map{
                                                        [0 rgbt 1] 
                                                        [.7 granite poly_wave 4 scale .1 pigment_map{[0 rgbt <1,1,1,.5>][.3 rgbt 1][1 rgbt <1,1,1,.5>]}]
                                                        
                                                        [1 rgbt 1]
                                                        }
                                                
                                                ] 
                                                [1 rgbt 1]
                                                }
                            ] 
                            
                            [1 granite scale 10 
                                   pigment_map{
                                                [0 rgb 100]
                                                [.7 granite scale .01 
                                                   
                                                           
                                                          
                                                 pigment_map{
                                                        [0 rgb 100] 
                                                        [.7 granite poly_wave 4 scale .001 pigment_map{[0 rgb 2][.3 rgb 1][1 rgb 2]}]
                                                        
                                                        [1 rgb 1]
                                                        }
                                                
                                                ] 
                                                [1 rgb 1]
                                                }
                            ] 
                            }
                   rotate y*-5
                   scale<0.021,0.02,0.021>/Scalar
                   rotate -Rotar
                  }
        // }
#declare t_smog=
texture{
          pigment{
                   wrinkles  scale <100,50,100>*22
                   turbulence <1,2,1>
                   lambda 2.5
                   omega 1.3
                   warp { turbulence <10,0,10>*.1
                         //lambda 3
                         omega 1.2
                         }
                   color_map{
                            [0 rgb 1 transmit 1]
                            //[.3 rgb <.3,.4,.1> transmit .9]
                            [1 rgb .5 transmit 0]
                            }
                   rotate y*15
                   scale<0.021,0.02,0.021>/Scalar
                    rotate -Rotar
                  }
         }
/*#declare t_smog=
texture{ wrinkles  rotate Rotar
                   scale Scalar
                   //lambda 2.5
                   omega 1.3
                   texture_map{
                            [0 t_clouds ]
                            [.3 pigment {rgb 1 transmit 1}]
                            [.5 t_clouds]
                            [.7 pigment {rgb 1 transmit 1}]
                            [1 t_clouds ]
                            }
                  }  */


#declare d_smog=
density{ wrinkles  rotate Rotar
                   scale Scalar
                   //lambda 2.5
                   omega 1.3
                   density_map{
                            [0 t_clouds ]
                            [.3 rgb 1 transmit 1]
                            [.5 t_clouds]
                            [.7 rgb 1 transmit 1]
                            [1 t_clouds ]
                            }
                  }
// Terrain /////////////////////////////////////////////
#declare Terrain=isosurface{  
 
function{(x*x+y*y+z*z-1)+f_granite(x*2,y*2,z*2)*f_agate(x,y,z)*.05}  // from Jaime's LightSys Space Demo scene
                  //max_gradient 3.199
                  //contained_by{sphere{0,1}}
//function{(x*x+y*y+z*z-1)+f_granite(x*2,y*2,z*2)*f_agate(x,y,z)*.05 +f_agate(x*100,y*100,z*100)*.001 -f_agate(x*1000,y*1000,z*1000)*.0001}
                  //max_gradient 3.199 
                  
                   //accuracy 1/1000000 // 1/1000000                   
                  hollow
                  }


// Planet
#declare PlanetBue=
union{
         isosurface{  
 
        function{(x*x+y*y+z*z-1)
                  +f_granite(x*2,y*2,z*2)*f_agate(x,y,z)*.05
                  +f_agate(x*100,y*100,z*100)*.001
                  -f_granite(x*1000,y*1000,z*1000)*.0001
                  
                  }
                  //max_gradient 3.199 
                 #if (clock>2)
                        accuracy 1/1000000 
                 #end      
                  contained_by{sphere{0,1}}
                   
                texture{t_planet 
                scale .02} 
                rotate z*.1
                  scale y*1.002
                  }


        #if(ShowWater)
                  sphere{0,1 // water 
                  /*isosurface{  
 
                        function{(x*x+y*y+z*z-1) -f_granite(x,y,z)*.001 }
                                  //max_gradient 3.199 
                                  accuracy 1/1000000
                                  contained_by{sphere{0,1.1}} */
                       pigment{gradient y scale 2 translate y
                               turbulence .1
                                lambda 7
                              pigment_map{
                                       [0 rgb<1,1,1> ]
                                       [.15 rgb <.1,.4,.7>  
                                                                  
                                       ]
                                       [.9 rgb <.1,.4,.7> //<0,.05,.2,.1> 
                                       
                                       ]
                                       [1 rgb<1,1,1> ]
                                       }
                               }
                       normal{granite .1  scale -.0005 }   
                        finish {ambient 0 diffuse.3 }//roughness .015 brilliance 3}
                      // #if(ShowMedia)
                          //finish{reflection{.3,1 fresnel on}   specular .3 brilliance 1.5}
                          
                          //interior{/*ior 1.31*/ fade_distance .003 fade_color rgb <0,.1,.3> }  
                         // interior {ior 1.31  fade_power 1001  fade_distance .001     fade_color <.1,.7,.9> }
                      // #end    
                       scale .996
                       hollow
                       } 
               //sphere{0,1 pigment{rgb <.1,.7,.9>} scale .9}
        #end
       #if(ShowMedia)
               
               sphere{0,1 
                       //#if(HighQuality=0) 
                           no_reflection// Atmosphere 
                      // #end
                       pigment{colour rgbt 1} 
                       //finish{specular 0  phong 0 reflection 0}
                       interior{//ior 1.1
                                media {
                                   method 3     
                                   //adaptive sampling 
                                   samples 60 //6 
                        	   intervals 1     
                	           jitter 1// .1  
                	           //variance 1.0/500
                	           scattering {4, rgb < 0.1, 0.4, 1>*3 extinction 1}
                                   /*#if(HighQuality=0)
                                        absorption (1-< 0.1, 0.4, 0.9>)*.5
                                   #end  */            
                                   density {onion
                                            density_map{
                                                    [0 rgb <.001,.01,.1>]
                                                    [.96 rgb <.001,.01,.1>*2]
                                                    [.97 rgb 1]  // earth
                                                    [.99 rgb .1]//
                                                    [1 rgb 0 ]//
                                                    }
                                           }
                                         } 
                                     
                                #if(ShowClouds) 
                                    media {
                			method 3 
                			samples 100 
                			intervals 1 
                			scattering {4, color rgb 1 extinction 1} 
                			absorption 1//10
                			density {onion //warp{ turbulence .01 }
                				
                				density_map {
                					[.89  rgb 0]
                					[.978  rgb 0]
                					[.979  d_clouds3 scale 470 rotate -35*z rotate y*70] 
                					[.981  d_clouds4 scale 470 rotate -35*z rotate y*70]
                					[.985  rgb 0]
                        				}
                        			
                        			}
                        			
                        			
                        			    
                        			
                                        
                                        } 
                                #end
                                }
                       rotate y*0
                       scale 1.03
                       hollow
                       double_illuminate  
                       //#if(HighQuality=0)
                           no_shadow 
                       //#end
                       }
        #end

        } 
        
        

// Planet
#declare PlanetHar=
union{   
         sphere{0,.9 pigment{agate colour_map{[0 rgb 0][1 rgb <1,0,0>]}}}
         isosurface{
 
        function{(x*x+y*y+z*z-1)+f_granite(x*2,y*2,z*2)*f_agate(x,y,z)*.05 +f_agate(x*100,y*100,z*100)*.001 -f_agate(x*1000,y*1000,z*1000)*.0001}
                          //max_gradient 3.199 
                          
                            accuracy 1/10000000 
                          
                          contained_by{sphere{0,1}}
                texture{t_planet_Har 
                scale .02}
                  scale y*1.002
                  hollow
                  double_illuminate
                  }
        
       #if(ShowMedia)
               
               sphere{0,1 
                       #if(HighQuality=0)
                           no_reflection// Atmosphere
                       #end
                       pigment{colour rgbt 1}
                       interior{
                                media {
                                   // (---general values---)
                                    intervals 1           // number of intervals used for sampling [1]...  always 1!!!
                                   samples 20            //minimum and maximum number of samples taken per interval [1,1]
                                   //scattering {2, rgb 100 } 
                                   scattering {4, rgb < 1, 0.4, .1>*3 extinction 1}
                                   /*#if(HighQuality=0)
                                        absorption 2 //(1-< 0.1, 0.4, 0.9>)*.5
                                   #end */
                                   //absorption 10 
                                   //jitter 1
                                   density {onion  

                                            density_map{
                                                    [0 rgb <.1,.01,.001>]
                                                    [.96 rgb <.1,.01,.001>*2]
                                                    [.97 rgb 1]  // earth
                                                    [.99 rgb .1]//
                                                    [1 rgb 0 ]//// 
                                                    /*
                                                    [.89 rgb 0]  // earth
                                                    [.9 granite scale .1 density_map{[0 rgb <.15,.2,.05>*10][1 rgb 0]} 
                                                    ]//
                                                    
                                                    [.93 granite scale .1 density_map{[0 rgb <.1,.05,.02>][1 rgb 0]}
                                                    
                                                    //rgb <.1,.05,.02>
                                                    ]//
                                                    [1 rgb 0 ]  */
                                                    }
                                           }
                                    }
                                #if(ShowClouds) 
                                    media {
                			method 3 
                			//samples 100 
                			intervals 1 
                			scattering {4, color rgb <.9,.8,.5>*3 extinction 1} 
                			absorption 1//10    
                			//jitter 1
                			density {onion //warp{ turbulence .01 }
                				
                				density_map {
                					//[.89  rgb 0]
                					//[.978  rgb 0]
                					//[.979  d_clouds3 scale 470 rotate -35*z rotate y*70] 
                					//[.979 d_smog scale 470 rotate -35*z rotate y*70] 
                					[.979  d_clouds4 scale 470 rotate -35*z rotate y*70] 
                					//[.981  d_clouds4 scale 470 rotate -35*z rotate y*70]
                					[.985  rgb 0]
                        				}
                        			
                        			}
                        			
                        			
                        			    
                        			
                                        
                                        } 
                                #end 
                                }
                       rotate y*90
                       scale 1.04
                       hollow
                       double_illuminate 
                       #if(HighQuality=0)
                           no_shadow  
                       #end
                       }
        #end           /*   */

         
         
                
        
        }

#declare PlanetDist=10;//40;
union{
// placement  of Planet Har
union{  #if(ShowRings)
         disc {<0, 0, 0>  y, 1.0, .15        // -O- RINGs -O-   
         
                         pigment{spherical
                                 cubic_wave
                                 colour_map{
                                            [0 rgbt <.1,.1,.1,1>] 
                                            [.76 rgbt <.2,.2,.2,.9>]   
                                            [.87 rgbt <.1,.1,.1,.1>]
                                            [.885 rgbt <.2,.1,.05,0>]
                                            [.9 rgbt <.1,.05,.01,1>]
                                            [.99 rgbt <.2,.1,.05,1>]
                                            
                                           
                                            }
                                 }
                         //normal{granite .001 scale .00001}
                         finish{ambient 0 diffuse .7 roughness .9 brilliance .2 } 
                         
                         scale 2*PlanetDist
                         hollow
                         double_illuminate
                         }
          #end
         object{PlanetHar rotate y*34 rotate z*2 no_radiosity}
         scale .3    
         //rotate z*30
         translate <0,0,0>   
         }  
         
// placement  of planet Bue
union{  #if(ShowRings)
         disc {<0, 0, 0>  y, 1.0, .15        // -O- RINGs -O- 
      
                         pigment{spherical
                                 cubic_wave
                                 colour_map{
                                            [0 rgbt <.1,.1,.15,1>] 
                                            [.6 rgbt <.2,.21,.25,.9>]   
                                            [.75 rgbt <.2,.22,.26,.5>]
                                            [.875 rgbt <.3,.2,.1,.5>]
                                            [.88 rgbt <.2,.2,.25,1>]
                                            [.9 rgbt <.25,.2,.15,0>]
                                            [.99 rgbt <.4,.3,.2,1>]
                                            }
                                 }
                         //normal{granite .001 scale .00001}
                         finish{ambient 0 diffuse .7 roughness .9 brilliance .2 }
                         scale 2*PlanetDist   
                         
                         hollow
                         double_illuminate
                         }
          #end
         object{PlanetBue rotate y*214}
         scale .3    
         
         translate <0,0,1.19*PlanetDist>    
         //rotate y*-5
         //rotate <0,0,30>
         }
              
}             

///////////////////////////////////////////////////////// 

     /*
isosurface{  // Close moon
 
function{(x*x+y*y+z*z-1)+f_granite(x*2,y*2,z*2)*f_agate(x,y,z)*.05 +f_agate(x*100,y*100,z*100)*.001 -f_agate(x*1000,y*1000,z*1000)*.0001}
                  //max_gradient 3.199 
                  
                    accuracy 1/10000000 
                  
                  contained_by{sphere{0,1}}
                   
                scale .25 rotate <-90,-90,-90.5> rotate <0,35,0> pigment{rgb .2} translate <0,.7518,-40> //<.48,.1,-.707>-z*40
                hollow
                }
                    */
              
    
 
/////////////////////////////////////////////////

light_source {<5,2,-2>*1000000, color <2.1,2,1.9>*2 
                media_attenuation on 
                media_interaction on
                }
sphere {<1,3,-3>*100, 7.5
	texture {
		pigment {color <2.1,2,1.9>/2}
		finish {ambient 10 diffuse 0}
	}
	no_shadow   
	hollow
	double_illuminate
}   


#declare CamPos=<0,1,-40>;
 
/////////////////////////MECHA/////////////////////////////////
     
   
#include"mechaircraft.inc" 
                             
#declare MechScale=.0002;

#declare Plasma=material{texture{pigment{rgbt 1}
                                 }
                         interior{
                                media {
                                          emission rgb<.1,5,20>*20  // emitting media, emit light of specified color
                                          scattering { 1, rgb <.1,2,4>*.1 }
                                          method 3               // adaptive sampling
                                         density { spherical warp{turbulence <0,.5,0>} colour_map {[.3 rgb 0][.5 rgb <.1,.5,1>][.7 rgb <.2,.9,1.1>][1 rgb 4]} }
                                        }
                                  }
                        }  

union{object{MechA }                       
        //sphere {0,1 material{Plasma }scale .8  hollow double_illuminate  translate <-3.6,0,-.15> hollow double_illuminate}
        light_source {0*x color rgb <.1,.2,.5> fade_distance .0001 fade_power 2 
                   
                   area_light
                  <.0001, 0, 0> <0, 0, .0001> // lights spread out across this distance (x * z)
                  2, 2                // total number of lights in grid (4x*4z = 16 lights)
                  adaptive 0          // 0,1,2,3...
                  jitter              // adds random softening of light
                  circular            // make the shape of the light circular
                  orient  
                    translate <-3.6,0,0> 
                    }
        /*sphere {0,1 material{Plasma }scale .8  hollow double_illuminate translate <4.2,0,-.15>  hollow double_illuminate}
        light_source {0*x color rgb <.1,.2,.5> fade_distance .0001 fade_power 2 
                  area_light
                  <.00001, 0, 0> <0, 0, .00001> // lights spread out across this distance (x * z)
                  2, 2                // total number of lights in grid (4x*4z = 16 lights)
                  adaptive 0          // 0,1,2,3...
                  jitter              // adds random softening of light
                  circular            // make the shape of the light circular
                  orient          
                translate <4.2,0,0>
                } */
        
        scale MechScale*<-1,1,1> rotate y*-90 
        rotate z*-90      
        rotate<-5,-30,-25>
        //  translate <0,1,-40> +<.002,-.0006,.014> 
        translate  <-.005,.3,0> +<-.0005,-.0015,.0035>   //<0,.299,0>//<0,0,.3>//<2,.1,3>/15//<0,0.2989, 0>//<0,.30055,0>//<0,.5,0>    // <.5,0,-1.2> 
        rotate <13,0,-65>
        }                           

//object{MechA scale .0015 rotate y*180 rotate <25,0,-35>  translate CamPos +<-.03,-.003,.02>}  

                             
/////////////////////////////////////////////////





///////////////////////////////////////////////////////////////
////////////// Camera ////////////////////////////////////////
 
#declare Clock=clock/3; 


#declare Clock1=clock*(clock<=1); 
#declare Clock2=(clock-1)*(clock>1)*(clock<=2);   
#declare Clock3=(clock-2)*(clock>2);   

//#declare ClockRot=(clock-1)*(clock>1)*(clock<=2)+(clock>2);  
#declare ClockRot=(clock-2)*(clock>2);  

#if (ClockRot>1)
 #declare ClockRot=1;
#end


#declare ClockCount=int(clock);

 
// har pos = translate <0,0,1.19*40> rotate y*-5  rotate <0,0,30> 
 

  


// still cam 
               
camera{   // on planet
  location <-.0048,.298,0>//<0,.299,0>//<0,0,.3>//<2,.1,3>/15//<0,0.2989, 0>//<0,.30055,0>//<0,.5,0>    // <.5,0,-1.2> 
  rotate <13.13,0,-65>
  //up y 
  sky <0,1,0>  
  //angle 60//50
  right x*image_width/image_height
  look_at <.15,.5,1.19> // 0//<2,.1,3>*1000000//<0,1,0>//<0,-.3,1> //<0,-.4,1> //   

}   
        
    /*      
      
camera{  // planet view
          location CamMid2 // (CamEnd*(2-(2/(EndClock+1))))+(CamStart*(1-StartClock))   //-.4 // <2,.1,3>/15//<0,0,.3>//<0,0.2989, 0>//<0,.30055,0>//<0,.5,0>    // <.5,0,-1.2> 
          rotate <16,0,-65>
          
          sky <0,1,0>
          right x*image_width/image_height
          look_at <0,.4,1.19> //0 // <2,.1,3>*1000000//<0,1,0>//0//<0,-.3,1> //<0,-.4,1> //   
        
        }   
        
        
      
camera{  // planet view
          location CamStart // (CamEnd*(2-(2/(EndClock+1))))+(CamStart*(1-StartClock))   //-.4 // <2,.1,3>/15//<0,0,.3>//<0,0.2989, 0>//<0,.30055,0>//<0,.5,0>    // <.5,0,-1.2> 
          rotate <16,0,30>
          
          sky <0,1,0>
          right x*image_width/image_height
          look_at <0,.4,1.19> //0 // <2,.1,3>*1000000//<0,1,0>//0//<0,-.3,1> //<0,-.4,1> //   
        
        }          
        
        

 
          
     
camera{  // original camera
          location <0,1.002,-40.03>  
          angle 10
          //rotate z*-30
          right x*image_width/image_height
          look_at <0,0,0>//(<0,.4,1.19>*ClockRot)+(<0,-.2,.5> *(1-Clock)) //0 // <2,.1,3>*1000000//<0,1,0>//0//<0,-.3,1> //<0,-.4,1> //   
        
        }        
         
          
camera{   // on planet
  location <.2988,0,.01>//<0,.299,0>//<0,0,.3>//<2,.1,3>/15//<0,0.2989, 0>//<0,.30055,0>//<0,.5,0>    // <.5,0,-1.2> 
  angle 20
  rotate <0,0,14>
  //up y 
  sky <1,0,0>
  right x*image_width/image_height
  look_at <.3,0,-1>// <0,0,1.19*40>//<.3,0,.3> // 0//<2,.1,3>*1000000//<0,1,0>//<0,-.3,1> //<0,-.4,1> //   

}            */